// Copyright  1997 Mario M. Westphal
// All Rights reserved
// This source code is only intended as a supplement to the
// Sort Solution user documentation and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Sort Solution product.

//{{AFX_INCLUDES()
#include "sortsol.h"
//}}AFX_INCLUDES

#if !defined(AFX_SOSOXDLG_H__82A88BB2_66F3_11D1_A560_0020AF498497__INCLUDED_)
#define AFX_SOSOXDLG_H__82A88BB2_66F3_11D1_A560_0020AF498497__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


//###########################################################################
// C S o s o x D l g 
//###########################################################################
class CSosoxDlg : public CDialog
{
public:
	CSosoxDlg(CWnd* pParent = NULL);	// standard constructor

private:
	bool	m_Running;		// Indicates a running sort


public:
	//{{AFX_DATA(CSosoxDlg)
	enum { IDD = IDD_SOSOX_DIALOG };
	CProgressCtrl	m_Progress_Sort;
	CProgressCtrl	m_Progress_Merge;
	CButton	m_Btn_Sort;
	CButton	m_Btn_Browse;
	CButton	m_Btn_Abort;
	CString	m_Edit;
	CSortSol	m_SortSol;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CSosoxDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;

	//{{AFX_MSG(CSosoxDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnAbort();
	afx_msg void OnBtnBrowse();
	afx_msg void OnBtnSort();
	afx_msg void OnSortPercentageSortsol(short Percentage);
	afx_msg void OnMergePercentageSortsol(short Percentage);
	virtual void OnCancel();
	virtual void OnOK();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOSOXDLG_H__82A88BB2_66F3_11D1_A560_0020AF498497__INCLUDED_)
